===================================================================
--- E:/projects/FLTK/fltk-svn-1.3/fluid/Fl_Function_Type.cxx	(revision 9984)
+++ E:/projects/FLTK/fltk-svn-1.3/fluid/Fl_Function_Type.cxx	(working copy)
@@ -987,14 +987,27 @@
     }
     const char*c = decl_before_input->value();
     while (isspace(*c)) c++;
-    message = c_check(c&&c[0]=='#' ? c+1 : c);
-    if (message) continue;
-    name(c);
-    c = decl_after_input->value();
-    while (isspace(*c)) c++;
-    message = c_check(c&&c[0]=='#' ? c+1 : c);
-    if (message) continue;
-    storestring(c,after);
+    if (strncmp(c,"namespace",9) != 0) {    
+      message = c_check(c&&c[0]=='#' ? c+1 : c);
+      if (message) continue;
+      name(c);
+      c = decl_after_input->value();
+      while (isspace(*c)) c++;
+      message = c_check(c&&c[0]=='#' ? c+1 : c);
+      if (message) continue;
+      storestring(c,after);
+    } else {
+      const char*c1 = decl_after_input->value();
+      while (isspace(*c1)) c1++;
+      char* cc = (char*)malloc(strlen(c)+strlen(c1)+1);
+      strcpy(cc,c);
+      strcat(cc,c1);
+      message = c_check(cc);
+      free(cc);
+      if (message) continue;
+      name(c);
+      storestring(c1,after);
+    }
     if (public_ != declblock_public_choice->value()) {
       set_modflag(1);
       public_ = declblock_public_choice->value();

===================================================================
--- E:/projects/FLTK/fltk-svn-1.3/fluid/Fl_Widget_Type.cxx	(revision 9984)
+++ E:/projects/FLTK/fltk-svn-1.3/fluid/Fl_Widget_Type.cxx	(working copy)
@@ -1964,11 +1964,22 @@
   return 0;
 }
 
+// recursive procedures call write_codeX for all decl blocks
+void write_declblocks_code1(Fl_Type* p) {
+  if (p->parent) write_declblocks_code1(p->parent);
+  if (p->is_decl_block()) p->write_code1();
+}
+void write_declblocks_code2(Fl_Type* p) {
+  if (p->is_decl_block()) p->write_code2();
+  if (p->parent) write_declblocks_code2(p->parent);    
+}
+
 void Fl_Widget_Type::write_static() {
   const char* t = subclassname(this);
   if (!subclass() || (is_class() && !strncmp(t, "Fl_", 3))) {
     write_declare("#include <FL/%s.H>", t);
   }
+  write_declblocks_code1(parent);
   for (int n=0; n < NUM_EXTRA_CODE; n++) {
     if (extra_code(n) && isdeclare(extra_code(n)))
       write_declare("%s", extra_code(n));
@@ -2039,6 +2050,7 @@
       write_c("))->%s_i(o,v);\n}\n", cn);
     }
   }
+  write_declblocks_code2(parent);
   if (image) {
     if (image->written != write_number) {
       image->write_static();
@@ -2050,7 +2062,7 @@
       inactive->write_static();
       inactive->written = write_number;
     }
-  }
+  }  
 }
 
 const char *Fl_Type::callback_name() {